//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Bitume 
//  Copyright (C) 2017 Arnaud Bouche (Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------------

/*************** System includes ***************/
#include <cpctelera.h>
#include "wincpctelera_helper.h"

/*************** Game includes ****************/
#include "structures.h"
#include "video.h"
#include "road.h"
#include "menus.h"
#include "game.h"
#include "sound.h"
#include "fontsHelper.h"

/*************** Extern functions **************/
extern void Initialize();

/*************** Global variables *************/
SRoad gRoad;
u8 gRoadColor;
u8 gMode;

/*****************************************************/
/*													 */
/*	Initialize							 			 */
/*												     */
/*****************************************************/
void InitPlay()
{
	SetGameInterrupt();
	SetGameFont(TRUE);
	SetBufferFont(BOTH_BUFFER);
	cpct_setVideoMode(0);
	InitGame();
	InitRoadScene();
	InitSFX();

	gMode = GAME;
}

/*****************************************************/
/*													 */
/*	Main entry										 */
/*												     */
/*****************************************************/
void main(void) 
{
	/** Change stack location must be the FIRST function called in main */
	cpct_setStackLocation((u8*)STACKLOC);

	WinCpcTelera_PrintHex("STACK_LIMIT", STACK_LIMIT);
	Initialize();
	
	while (TRUE)
	{
		(gMode & MENU) ? Menu() : Game();
	};
}
