//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Bitume 
//  Copyright (C) 2017 Arnaud Bouche (Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------------

void InitImpacts();
void DrawImpacts();

void UpdateShoot(SCar* car);
void UpdateShootCounter(SCar *car);
u8 GetShootDirection(u8 weapon);
BOOL IsCarHit(SCar* car, u8 weapon, u8* shootX, u8* shootY);
BOOL TestHit(SCar* car, u8 shootX, u8 shootY);
void DrawShoot(SCar *car);
void UpdateCarAndGunPos(SCar *car);
void ClearShoot(SCar *carShooter);

enum
{
	GUN_NOTHING = 0x00,
	GUN_UP = 0x01,
	GUN_DOWN = 0x02,
	GUN_RIGHT = 0x04,
	GUN_LEFT = 0x08,
	GUN_SIMPLE = 0x10,
	GUN_DOUBLE = 0x20,
	GUN_HEAVY_GUN = 0x40,
	GUN_AMMO_ANTIARMOR = 0x80
};

#define GUN_SIMPLE_RIGHT			(GUN_SIMPLE|GUN_RIGHT)
#define GUN_DOUBLE_RIGHT			(GUN_DOUBLE|GUN_RIGHT)
#define GUN_SIMPLE_LEFT				(GUN_SIMPLE|GUN_LEFT)
#define GUN_DOUBLE_LEFT				(GUN_DOUBLE|GUN_LEFT)
#define GUN_HEAVY_LEFT				(GUN_HEAVY_GUN|GUN_LEFT)
#define GUN_DOUBLE_RIGHT_ANTIARMOR	(GUN_DOUBLE|GUN_RIGHT|GUN_AMMO_ANTIARMOR)