//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Bitume 
//  Copyright (C) 2017 Arnaud Bouche (Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------------

void InitRoadScene();

u8 GetSpriteCenterY(const SSpriteInfo* sprite);
void SetCoord(SRoadObject* obj, i8 x, u8 y);
u8 GetLimitSpriteY(SSpriteInfo* sprite);
u8 GetLimitY(u8 y, u8 cy);
i8 GetLimitX(i8 x);
u8 GetRandPositionY();
u8 GetRandPositionX();

void InitRoad();
void DrawRoadBorder();
void DrawRoadObjectBackground(const SSpriteInfo* spriteInfo);
void ClearRoadObject(SSpriteInfo* spriteInfo);
void ClearFlamesBackground(SCar *car);
void DrawFlames(SCar *car);

void DeleteRoadObject(SRoadObject* objects, SRoadObject* objToDel, u8* nb);
void DeleteRoadObjects(SRoadObject* explosives, u8* nb);
void DrawRoadObject(SRoadObject* objMine, u8 timer, u8** spritesState, u8 index);
void CollideRoadObject(SRoadObject* objExpl, SCar* collidedCar);
void AddRoadBonus(u8 money);
u8 GetBonusType();

void ClearRoadObjects(SRoadObject* explosives, u8 nb);

void StartRound();
void DrawEndGame();

BOOL TestCollision(SSpriteInfo* A, SSpriteInfo* B);
BOOL TestHorizontalCollision(SSpriteInfo* A, SSpriteInfo* B);
BOOL TestVerticalCollision(SSpriteInfo* A, SSpriteInfo* B);
SCar* TestCarCollision(SSpriteInfo* object);

#define GET_SIZE_X(spriteInfo)	(spriteInfo)._cx
#define GET_SIZE_Y(spriteInfo)	(spriteInfo)._cy
#define GET_POS_X(spriteInfo)	(spriteInfo)._x
#define GET_POS_Y(spriteInfo)	(spriteInfo)._y

#define OFFSET_LIMIT		7

#define LIMIT_DOWN			(u8)(SCREEN_CY_BYTE - ROAD_BORDER_CY - OFFSET_LIMIT)
#define LIMIT_DOWN_PLAYER	(u8)(SCREEN_CY_BYTE - PLAYER_CY - ROAD_BORDER_CY - OFFSET_LIMIT)
#define START_DOWN_CAR		(u8)(SCREEN_CY_BYTE - ROAD_BORDER_CY - OFFSET_LIMIT)
#define LIMIT_UP			(u8)(BOARD_CY + ROAD_BORDER_CY + OFFSET_LIMIT)
#define START_UP_CAR		LIMIT_UP

#define START_QUARTER_1		(START_UP_CAR + 15)
#define START_QUARTER_2		(START_UP_CAR + 50)
#define START_QUARTER_3		(START_UP_CAR + 80)
#define START_QUARTER_4		(START_UP_CAR + 110)

#define START_MID_CAR		(SCREEN_CY_BYTE/2)
#define START_RAND_CAR		0
#define LIMIT_RIGHT			(i8)(SCREEN_CX_BYTE - PLAYER_CX - 1)
#define LIMIT_LEFT			(i8)1

#define IsRoundFinished()	(gRoad._cars._nbCars == 0)
#define IsLevelFinished()	(gRoad._curRound == NB_ROUND_MAX)
#define IsGameWin()			(gRoad._curLevel == NB_LEVEL_MAX)

extern SRoad gRoad;
extern u8 gRoadColor;