//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Bitume 
//  Copyright (C) 2017 Arnaud Bouche (Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------------

#ifndef SOUND_FX_H
#define SOUND_FX_H

#define FX_ADDRESS		0x40
#define FX_LENGTH		0xE7
#define MUSIC_ADDRESS	0x8000

enum
{
	FX_IMPACT = 1,
	FX_SHOOT,
	FX_BONUS,
	FX_EXPLOSION,
	FX_SELECT,
	FX_MISSILE
};

enum
{
	FX_IMPACT_CHANNEL = AY_CHANNEL_B,
	FX_SHOOT_CHANNEL = AY_CHANNEL_A,
	FX_BONUS_CHANNEL = AY_CHANNEL_C,
	FX_EXPLOSION_CHANNEL = AY_CHANNEL_C,
	FX_SELECT_CHANNEL = AY_CHANNEL_A,
	FX_MISSILE_CHANNEL = AY_CHANNEL_A
};

void PlaySFX(u8 fx, u8 channel);
void InitSFX();

#define InitMusic() cpct_akp_musicInit((u8*)MUSIC_ADDRESS)
#define PlaySound() cpct_akp_musicPlay()
#define StopMusic() cpct_akp_stop()
#define StopSFX() cpct_akp_SFXStopAll()

#endif