//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of Bitume 
//  Copyright (C) 2017 Arnaud Bouche (Arnaud6128)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//-------------------------------------------------------------------------------

u8 GetVMemIndex();
void SetDisplay(u8 vMem);
void FlipBuffer();
void SetAllPaletteBlack();
void SetFullPalette(u8* palette);

u8* GetScreenPtr(u8 xPos, u8 yPos);
u8* GetBackScreenPtr(u8 xPos, u8 yPos);
u8* GetOriginBackScreenPtr();
u8* GetOriginScreenPtr();

void ClearScreenZone(i8 xPos, u8 yPos, u8 cx, u8 cy, u8 pBufferScreen);
void StoreCurrentPos(SSpriteInfo* sprite);
i8 GetPosRightX(SSpriteInfo* sprite);
u8 GetPosRightY(SSpriteInfo* sprite);

void DrawClippedRoadObjectOpaque(SRoadObject* pObj);
void DrawClippedSprite(const u8* sprite, i8 xPos, u8 yPos, u8 width, u8 height, u8 masked, u8 isBackBuffer);
void DrawSpriteBothBuffers(const u8* pSprite, u8 x, u8 y, u8 cx, u8 cy, u8 masked);
void DrawSpriteType(void* sprite, void* memory, u8 width, u8 height, u8 spriteType);

cpctm_declareMaskTable(gMaskTable);

#define IN_SCREEN(xRight, xLeft) (xRight > 0 && xLeft < SCREEN_CX_BYTE)
